'freebasic
rem *****************************************
rem * xml2play.bas                          *
rem * Written by Deckard of AtD 5 May 2023  *
rem * http://atd-group.narod.ru             *
rem *****************************************
option gosub
DEFLNG A-Z
const debug=0
declare function exists(n$) as long
declare sub equit(txt$)
declare sub equit2(txt$)
dim shared music$(100),a$
dim shared nlines as long,inplines as long
'SCREEN 12
print "XML2PLAY converts MusicXML files"
print "from MuseScore 4 to Arduino DKQBPLAY .h files"
print "(QB/QBasic PLAY statement format)"
print "(C) Dmitriy Korabelnikov AtD 2023"
print string$(79,"_")
print
print " input file [score]:";
line input fi$:if fi$="" then fi$="score"
print "output file [score]:";
line input fo$:if fo$="" then fo$="score"
fi$=fi$+".xml"
if not exists(fi$) then equit fi$+" - file not found"
OPEN fi$ FOR BINARY AS #1
GOSUB getline
GOSUB getline
p=instr(a$,"MusicXML 4.0")
if p=0 then equit "MusicXML 4.0 data file expected"
nlines=0:inplines=0
old$ = ""
print "processing..."

WHILE NOT EOF(1)
GOSUB getline
if instr(a$,"<divisions>") > 0 then
    p = instr(a$,">")+1
    divis=val(mid$(a$,p,1))
    if not (divis=2 or divis=4) then
        equit2 "2 or 4 expected"
    end if
    goto main
end if
WEND
    equit "<divisions> not found"

main:
if divis=2 then mus$ = "L8":deft$="8"
if divis=4 then mus$ = "L16":deft$="16"
WHILE NOT EOF(1)
GOSUB getline
IF INSTR(a$, "<note") > 0 THEN
    GOSUB getline
    m$ = ""
    v1 = (INSTR(a$, "<pitch>") > 0)
    v2 = (INSTR(a$, "<rest/>") > 0)
'if note
    IF v1 THEN
	m$ = "note"
	GOSUB getline
	p=instr(a$,"<step>")
	if p=0 then equit2 "<step> expected"
	nota$ = MID$(a$, INSTR(a$, ">") + 1, 1)
	alt$ = "0"
	GOSUB getline
	IF INSTR(a$, "<alter>") > 0 THEN
	   alt$ = MID$(a$, INSTR(a$, ">") + 1, 1)
	   GOSUB getline
	END IF
	p=instr(a$,"<octave>")
	if p=0 then equit2 "<octave> expected"
	ooo$ = MID$(a$, INSTR(a$, ">") + 1, 1)
	GOSUB getline
	GOSUB getline
	p=instr(a$,"<duration>")
	if p=0 then equit2 "<duration> expected"
	ttt$ = MID$(a$, INSTR(a$, ">") + 1):ttt$=MID$(ttt$,1, INSTR(ttt$, "<") - 1)
     END IF
' if rest
     IF v2 THEN
	m$ = "rest"
	GOSUB getline: ttt$ = MID$(a$, INSTR(a$, ">") + 1):ttt$=MID$(ttt$,1, INSTR(ttt$, "<") - 1)
      END IF
'if note
IF v1 THEN
   if debug then PRINT m$; nota$; ooo$; ttt$
   gosub convt
   ooo$ = LTRIM$(STR$(VAL(ooo$) - 1))
   IF alt$ = "1" THEN nota$ = nota$ + "+"
   IF alt$ = "-" THEN nota$ = nota$ + "-"
   IF old$ <> ooo$ THEN mus$ = mus$ + "o" + ooo$: old$ = ooo$
   mus$ = mus$ + nota$ + t$
END IF
' if rest
IF v2 THEN
   if debug then PRINT "pause !":PRINT m$; ttt$
   gosub convt
   mus$ = mus$ + "p" + t$
END IF
DO: GOSUB getline: LOOP WHILE INSTR(a$, "</note>") > 0
END IF
if len(mus$)>=64 then
    music$(nlines)=mus$:nlines=nlines+1:mus$=""
end if
WEND
gosub wrtmus
END

getline:
a$ = ""
DO
IF EOF(1) THEN GOSUB wrtmus: END
IF INKEY$ = CHR$(27) THEN END
q$ = INPUT$(1, 1)
IF q$ <> CHR$(10) THEN a$ = a$ + q$
LOOP WHILE q$ <> CHR$(10)
'PRINT a$
inplines=inplines+1
RETURN

wrtmus:
OPEN fo$+".h" FOR OUTPUT AS #2
OPEN fo$+".bas" FOR OUTPUT AS #3
PRINT #2, "const PROGMEM unsigned char notes[]=\"
if len(mus$)>0 then
    music$(nlines)=mus$:nlines=nlines+1:mus$=""
end if
e$ = CHR$(34)
for i=0 to nlines-1
    PRINT #2, e$; music$(i); e$;
    if i<nlines-1 then print #2,"" else print #2,";"
    PRINT #3,"PLAY "; e$; music$(i); e$
next i
CLOSE #2,#3
PRINT "ok": SLEEP
RETURN

convt:
if not (divis=2 or divis=4) then equit2 "<divisions> - 2 or 4 expected"
if divis=2 then RESTORE datslow
if divis=4 then RESTORE dat
WHILE 1
READ x$, y$
IF ttt$ = x$ THEN
 t$ = y$
 if v1<>0 and t$=deft$ then t$=""
 RETURN
end if
IF x$ = "0" THEN equit2 "Invalid len:"+ttt$
WEND
RETURN

datslow:
DATA "1","8"
DATA "2","4"
DATA "3","4."
DATA "4","2"
DATA "6","2."
DATA "8","1"
DATA "12","1."
DATA "0","0"

dat:
DATA "1","16"
DATA "2","8"
DATA "3","8."
DATA "4","4"
DATA "6","4."
DATA "8","2"
DATA "12","2."
DATA "16","1"
DATA "24","1."
DATA "0","0"

sub equit(txt$)
close:print txt$:sleep:end
end sub

sub equit2(txt$)
close
print "Error in line ";inplines;":";a$
print txt$:sleep
end
end sub

' Is file n$ exist ?
function exists(n$) as long
re=open(n$,for input,as #9)
close #9
if re=0 then exists=-1 else exists=0
end function
